;---- H&A Function to print list of c:functions------------
;you would use your own paths, and this might end up being one line at your company
;like (PRINTKEYSAUX "company key-in file.lsp") where that file is in your support paths.
(DEFUN C:PRINTKEYS ( / CPATH LST HA-CUSTOM-PATHLOC PROFFLDR)
  ;FIGURE THE USER FILE PATH BY ACAD VERSION
  (COND
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\V20*")(SETQ CPATH "B2020"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\V19*")(SETQ CPATH "B2019"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\V18*")(SETQ CPATH "B2018"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\V17*")(SETQ CPATH "B2017"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\V16*")(SETQ CPATH "B2016"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\V15*")(SETQ CPATH "B2015"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\V14*")(SETQ CPATH "B2014"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\V13*")(SETQ CPATH "B2013"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\V12*")(SETQ CPATH "B2012"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\R23.1*")(SETQ CPATH "A2020"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\R23.0*")(SETQ CPATH "A2019"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\R22.0*")(SETQ CPATH "A2018"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\R21.0*")(SETQ CPATH "A2017"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\R20.1*")(SETQ CPATH "A2016"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\R20.*")(SETQ CPATH "A2015"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\R19.*")(SETQ CPATH "A2014"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\R18.2*")(SETQ CPATH "A2013"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\R18.1*")(SETQ CPATH "A2012"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\R18.*")(SETQ CPATH "A2011"))
    ((WCMATCH (VLAX-PRODUCT-KEY) "*\\R17.*")(SETQ CPATH "A2009"))
  )
  ;ASSUME +Key-Ins.lsp IS AVAILABLE, IT BETTER BE
  (SETQ LST (LIST (FINDFILE "+Key-Ins.lsp")))
  (SETQ PROFFLDR (substr (getenv "USERPROFILE") 10))
  ;WE STORE USER LISP ON C DRIVE NOW, WITH SO MANY REMOTE USERS
  (SETQ HA-CUSTOM-PATHLOC (strcat "C:\\J Drive Local\\Acaduser\\" PROFFLDR "\\AcadSettings\\" CPATH "\\" (getvar "loginname") ".lsp"))
  (IF (FINDFILE HA-CUSTOM-PATHLOC)
    (SETQ LST (APPEND LST (LIST HA-CUSTOM-PATHLOC)))
  )
  (PRINTKEYSAUX LST)
  (PRINC)
)

(DEFUN PRINTKEYSAUX (FPATHS / DESC END ENDFUN FUNNAME LST PRINTKEYS:PATTERN ST STFUN STFUNTXT STTEXT TMP)
	(PRINC "\nSearches for Key-Ins.")
	(IF (NOT PRINTKEYS:PATTERN)(SETQ PRINTKEYS:PATTERN "*"))
	(SETQ TMP (GETSTRING (STRCAT "\nSearch for Items containing <" PRINTKEYS:PATTERN ">:")))
	(IF (/= TMP "")(SETQ PRINTKEYS:PATTERN TMP))
	(IF (/= (SUBSTR PRINTKEYS:PATTERN 1 1) "*")
		(SETQ PRINTKEYS:PATTERN (STRCAT "*" PRINTKEYS:PATTERN))
	)
	(IF (/= (SUBSTR PRINTKEYS:PATTERN (STRLEN PRINTKEYS:PATTERN) 1) "*")
		(SETQ PRINTKEYS:PATTERN (STRCAT PRINTKEYS:PATTERN "*"))
	)
	;READ IN FILES TO LIST
	(FOREACH FPATH FPATHS
		(IF (NOT LST)
			(SETQ LST (FILE-TO-LST-ALL (FINDFILE FPATH)))
			(SETQ LST (APPEND LST (FILE-TO-LST-ALL (FINDFILE FPATH))))
		)
	)
		
	(FOREACH ITEM LST
		(IF (AND (NOT (= ";" (SUBSTR ITEM 1 1)))
						 (SETQ ST (vl-string-search "(PRINCM " (STRCASE ITEM)))
						 (SETQ STTEXT (SUBSTR (STRCASE ITEM) (+ ST 8)))
						 (SETQ END (vl-string-search "\")" STTEXT))
			       (OR (SETQ STFUN (vl-string-search "DEFUN C:" (STRCASE ITEM)))
								 (SETQ STFUN (vl-string-search "DEFUN\tC:" (STRCASE ITEM)))
						 )
						 (SETQ STFUNTXT (SUBSTR (STRCASE ITEM) (+ STFUN 9)))
						 (SETQ ENDFUN (vl-string-search "(" STFUNTXT))
						 (SETQ FUNNAME (SUBSTR ITEM (+ STFUN 9) (- ENDFUN 1)))
						 (SETQ DESC (SUBSTR ITEM (+ ST 12) (- END 4)))
						 (OR (WCMATCH (STRCASE FUNNAME) (STRCASE PRINTKEYS:PATTERN))
								 (WCMATCH (STRCASE DESC) (STRCASE PRINTKEYS:PATTERN))
						 )
				)
			(PRINC (STRCAT "\n" FUNNAME " - " DESC))
		)

	)
  (PRINC)
)

(defun FILE-TO-LST-ALL (Fil
												/ FilObj FilPth FilSys OpnFil RetVal
												FileH TextString)
 (if (setq FilPth (findfile Fil))
  (progn
   (setq FilSys (vlax-create-object "Scripting.FileSystemObject")
         FilObj (vlax-invoke FilSys "GetFile" FilPth)
         OpnFil (vlax-invoke FilObj "OpenAsTextStream" 1 0)
   )
   (while (= (vlax-get OpnFil "AtEndOfStream") 0)
    (setq RetVal (cons (vlax-invoke OpnFil "ReadLine") RetVal))
   )
   (vlax-invoke OpnFil "Close")
   (vlax-release-object OpnFil)
   (vlax-release-object FilObj)
   (vlax-release-object FilSys)
   (reverse RetVal)
  )
  nil
 )
)